# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
dirac_instr::DrawOverlay Class Referenceabstract

Base class for block overlay objects.

`#include <draw_overlay.h>`

Inheritance diagram for dirac_instr::DrawOverlay:
[legend]
Collaboration diagram for dirac_instr::DrawOverlay:
[legend]

## Public Member Functions
| DrawOverlay (Picture &, DrawPictureMotionParams &)
| Constructor. More...
virtual | ~DrawOverlay ()
| Destructor. More...
virtual void | DrawBlock (int, int)=0
| Carries out overlay for single block. More...
virtual void | DrawLegend ()=0
| Draws overlay legend. More...
void | DrawReferenceNumbers (int, int)
| Draws picture numbers for both references. More...
void | DrawReferenceNumber (int, int)
| Draws picture number for chosen reference. More...
void | DrawPictureNumber (int)
| Draws current picture number. More...
void | DrawCharacter (const PicArray &, int, int)
| Draws a character / number / symbol. More...
const OverlaySymbols & | Symbols () const
| Returns reference to symbols object. More...

## Protected Member Functions
void | GetPowerUV (int, int &, int &)
| Calculates U and V for particular value normalised to 1000. More...
void | DrawPowerBar (int, int)
| Draws power bar legend with given limits. More...
void | DrawValue (int, int, int)
| Draws value. More...
void | DrawMvBlockUV (int, int, int, int)
| Colours motion vector block referenced by motion vector. More...
void | DrawBlockUV (int, int, int, int)
| Colours an 8x8 block referenced by TL chroma pixel. More...

## Protected Attributes
Picture & | m_picture
| Picture data. More...
DrawPictureMotionParams & | m_draw_params
| Block parameters and chroma scaling. More...
OverlaySymbols | m_symbols
| Symbols. More...

## Constructor & Destructor Documentation

## ◆ DrawOverlay()

dirac_instr::DrawOverlay::DrawOverlay | ( | Picture & | ,
|  | DrawPictureMotionParams & |
| ) |  |

## ◆ ~DrawOverlay()

virtual dirac_instr::DrawOverlay::~DrawOverlay | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ DrawBlock()

virtual void dirac_instr::DrawOverlay::DrawBlock | ( | int | ,
|  | int |
| ) |  |
| pure virtual

Implemented in dirac_instr::DrawGMInliers, dirac_instr::DrawMotionArrows, dirac_instr::DrawMotionColour, dirac_instr::DrawMotionColourArrows, dirac_instr::DrawPredMode, dirac_instr::DrawSad, and dirac_instr::DrawSplitMode.

## ◆ DrawBlockUV()

void dirac_instr::DrawOverlay::DrawBlockUV | ( | int | ,
|  | int | ,
|  | int | ,
|  | int |
| ) |  |
| protected

## ◆ DrawCharacter()

void dirac_instr::DrawOverlay::DrawCharacter | ( | const PicArray & | ,
|  | int | ,
|  | int |
| ) |  |

## ◆ DrawLegend()

virtual void dirac_instr::DrawOverlay::DrawLegend | ( |  | ) |
| pure virtual

Implemented in dirac_instr::DrawGMInliers, dirac_instr::DrawMotionArrows, dirac_instr::DrawMotionColour, dirac_instr::DrawMotionColourArrows, dirac_instr::DrawPredMode, dirac_instr::DrawSad, and dirac_instr::DrawSplitMode.

## ◆ DrawMvBlockUV()

void dirac_instr::DrawOverlay::DrawMvBlockUV | ( | int | ,
|  | int | ,
|  | int | ,
|  | int |
| ) |  |
| protected

## ◆ DrawPictureNumber()

void dirac_instr::DrawOverlay::DrawPictureNumber | ( | int |  | ) |

## ◆ DrawPowerBar()

void dirac_instr::DrawOverlay::DrawPowerBar | ( | int | ,
|  | int |
| ) |  |
| protected

## ◆ DrawReferenceNumber()

void dirac_instr::DrawOverlay::DrawReferenceNumber | ( | int | ,
|  | int |
| ) |  |

## ◆ DrawReferenceNumbers()

void dirac_instr::DrawOverlay::DrawReferenceNumbers | ( | int | ,
|  | int |
| ) |  |

## ◆ DrawValue()

void dirac_instr::DrawOverlay::DrawValue | ( | int | ,
|  | int | ,
|  | int |
| ) |  |
| protected

## ◆ GetPowerUV()

void dirac_instr::DrawOverlay::GetPowerUV | ( | int | ,
|  | int & | ,
|  | int & |
| ) |  |
| protected

## ◆ Symbols()

const OverlaySymbols & dirac_instr::DrawOverlay::Symbols | ( |  | ) | const
| inline

References m_symbols.

## Member Data Documentation

## ◆ m_draw_params

DrawPictureMotionParams& dirac_instr::DrawOverlay::m_draw_params
| protected

## ◆ m_picture

Picture& dirac_instr::DrawOverlay::m_picture
| protected

## ◆ m_symbols

OverlaySymbols dirac_instr::DrawOverlay::m_symbols
| protected

Referenced by Symbols().

The documentation for this class was generated from the following file:

- draw_overlay.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.